# at_quick_exit

From cppreference.com
< c‎ | program

Defined in header `<stdlib.h>` |  |
int at_quick_exit( void (*func)(void) ); |  | (since C11)

Registers the function pointed to by `func` to be called on quick program termination (via quick_exit).

Calling the function from several threads does not induce a data race. The implementation shall support the registration of at least 32 functions.

### Parameters

func | - | pointer to a function to be called on quick program termination

### Return value

​0​ if the registration succeeds, nonzero value otherwise.

### Example

Run this code

    #include <stdlib.h>
    #include <stdio.h>

    void f1(void)
    {
        puts("pushed first");
        fflush(stdout);
    }

    void f2(void)
    {
        puts("pushed second");
    }

    int main(void)
    {
        at_quick_exit(f1);
        at_quick_exit(f2);
        quick_exit(0);
    }

Output:

    pushed second
    pushed first

### References

- C11 standard (ISO/IEC 9899:2011):

  - 7.22.4.3 The at_quick_exit function (p: 351)

### See also

atexit | registers a function to be called on exit() invocation (function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=c/program/at_quick_exit&oldid=97775"